000100 IDENTIFICATION DIVISION.                                         POS00112
000200 PROGRAM-ID.      PWRDPK.                                         SOBEMAP.
000300                                                                  SOBEMAP.
000400 AUTHOR.          LEIF SVALGAARD.                                 SOBEMAP.
000500 DATE-WRITTEN.    87/01/15                                        SOBEMAP.
000600     -REVISED:    96/08/15.                                       96/08/15
000700                                                                  SOBEMAP.
000800 ENVIRONMENT DIVISION.                                            SOBEMAP.
000900                                                                  SOBEMAP.
001000 CONFIGURATION SECTION.                                           SOBEMAP.
001100 SOURCE-COMPUTER. PORTABLE.                                       SOBEMAP.
001200 OBJECT-COMPUTER. PORTABLE.                                       SOBEMAP.
001300                                                                  SOBEMAP.
001400 DATA DIVISION.                                                   SOBEMAP.
001500                                                                  SOBEMAP.
001600 WORKING-STORAGE SECTION.                                         SOBEMAP.
001700                                                                  SOBEMAP.
001800 01  CONVPK-CONTROL.                                              SOBEMAP.
001900     02  CONVPK-TASK-ID              PIC X(4).                    SOBEMAP.
002000     02  CONVPK-OPERATION            PIC X      VALUE "C".        SOBEMAP.
002100     02  CONVPK-FEEDBACK             PIC X      VALUE SPACE.      96/08/15
002200     02  CONVPK-SIZE                 PIC S9(3)  COMP.             96/08/15
002300                                                                  SOBEMAP.
002400 01  CONVPK-LINE.                                                 SOBEMAP.
002500     02  CHAR                        PIC X      OCCURS 81 TIMES.  SOBEMAP.
002600                                                                  SOBEMAP.
002700 01  CONVPK-RESULT.                                               87/12/22
002800     02  CHAR-VALUE                  PIC S9(3)  COMP              96/08/15
002900                                                OCCURS 81 TIMES.  SOBEMAP.
003000                                                                  87/12/22
003100 01  ENCRYPTION-VARIABLES.                                        SOBEMAP.
003200     02  CRYPTO-SQUARE               PIC S9(9)  COMP.             SOBEMAP.
003300     02  CRYPTO-TERM                 PIC S9(9)  COMP.             SOBEMAP.
003400     02  CRYPTO-JUNK                 PIC S9(9)  COMP.             SOBEMAP.
003500     02  CRYPTO-KEY                  PIC S9(3)  COMP.             87/12/22
003600                                                                  SOBEMAP.
003700     02  TEXT-LENGTH                 PIC S9(3)  COMP.             87/12/22
003800     02  THIS-CHAR                   PIC S9(3)  COMP.             SOBEMAP.
003900     02  NEXT-CHAR                   PIC S9(3)  COMP.             SOBEMAP.
004000                                                                  SOBEMAP.
004100     02  CRYPTO-HUGE                 PIC 9(18).                   94/04/20
004200     02  FILLER                      REDEFINES CRYPTO-HUGE.       94/04/20
004300         03  FILLER                  PIC 9(03).                   94/04/20
004400         03  CRYPTO-HUGE-NBR         PIC 9(15).                   94/04/20
004500     02  FILLER                      REDEFINES CRYPTO-HUGE.       94/04/20
004600         03  FILLER                  PIC 9(08).                   94/04/20
004700         03  CRYPTO-HUGE-SUM         PIC 9(10).                   94/04/20
004800                                                                  94/04/20
004900     02  CRYPTO-PART1                PIC 9(18).                   94/04/22
005000     02  FILLER                      REDEFINES CRYPTO-PART1.      94/04/22
005100         03  FILLER                  PIC 9(08).                   94/04/22
005200         03  CRYPTO-PART1-HI         PIC 9(05).                   94/04/22
005300         03  CRYPTO-PART1-LO         PIC 9(05).                   94/04/22
005400                                                                  94/04/22
005500     02  CRYPTO-PART2                PIC 9(18).                   94/04/22
005600     02  FILLER                      REDEFINES CRYPTO-PART2.      94/04/22
005700         03  FILLER                  PIC 9(08).                   94/04/22
005800         03  CRYPTO-PART2-HI         PIC 9(05).                   94/04/22
005900         03  CRYPTO-PART2-LO         PIC 9(05).                   94/04/22
006000                                                                  94/04/22
006100     02  CRYPTO-RESULT               PIC 9(18).                   94/04/22
006200     02  FILLER                      REDEFINES CRYPTO-RESULT.     94/04/22
006300         03  CRYPTO-RESULT-HI        PIC 9(13).                   94/04/22
006400         03  CRYPTO-RESULT-LO        PIC 9(05).                   94/04/22
006500     02  FILLER                      REDEFINES CRYPTO-RESULT.     94/04/22
006600         03  CRYPTO-RESULT-08        PIC 9(08).                   94/04/22
006700         03  CRYPTO-RESULT-10        PIC 9(10).                   94/04/22
006800                                                                  94/04/22
006900     02  CRYPTO-MULT1                PIC 9(18).                   94/04/22
007000     02  CRYPTO-MULT2                PIC 9(18).                   94/04/22
007100     02  CRYPTO-MULT3                PIC 9(18).                   94/04/22
007200                                                                  94/04/22
007300     02  CRYPTO-NUMBER               PIC 9(15).                   SOBEMAP.
007400     02  FILLER                      REDEFINES CRYPTO-NUMBER.     SOBEMAP.
007500         03  CRYPTO-1                PIC 9(5).                    SOBEMAP.
007600         03  CRYPTO-2                PIC 9(5).                    SOBEMAP.
007700         03  CRYPTO-3                PIC 9(5).                    SOBEMAP.
007800                                                                  SOBEMAP.
007900     02  CRYPTO-SUM                  PIC 9(10).                   SOBEMAP.
008000     02  CRYPTO-VALUE                PIC 9(10).                   SOBEMAP.
008100                                                                  SOBEMAP.
008200 LINKAGE SECTION.                                                 SOBEMAP.
008300                                                                  SOBEMAP.
008400 01  PWRDPK-CONTROL.                                              SOBEMAP.
008500     02  PWRDPK-TASK-ID              PIC X(4).                    SOBEMAP.
008600     02  PWRDPK-OPERATION            PIC X.                       SOBEMAP.
008700         88  ENCRYPT-PASSWORD                 VALUE IS "E".       SOBEMAP.
008800     02  PWRDPK-FEEDBACK             PIC X.                       SOBEMAP.
008900                                                                  SOBEMAP.
009000     02  PWRDPK-USER-ID              PIC X(08).                   SOBEMAP.
009100     02  PWRDPK-PASSWORD             PIC X(80).                   SOBEMAP.
009200     02  PWRDPK-CRYPTO-VALUE         PIC 9(10).                   SOBEMAP.
009300     02  PWRDPK-CRYPTO-MASK          PIC 9(10).                   SOBEMAP.
009400                                                                  SOBEMAP.
009500 PROCEDURE DIVISION                                               SOBEMAP.
009600     USING PWRDPK-CONTROL                                         SOBEMAP.
009700     .                                                            SOBEMAP.
009800                                                                  SOBEMAP.
009900 BEGIN-PROGRAM.                                                   SOBEMAP.
010000     MOVE PWRDPK-TASK-ID TO CONVPK-TASK-ID                        SOBEMAP.
010100     MOVE SPACE          TO PWRDPK-FEEDBACK                       SOBEMAP.
010200                                                                  SOBEMAP.
010300     IF ENCRYPT-PASSWORD                                          SOBEMAP.
010400         PERFORM ENCRYPT-THE-PASSWORD                             SOBEMAP.
010500         PERFORM ERASE-THE-PASSWORD                               87/12/27
010600     ELSE                                                         SOBEMAP.
010700         MOVE "O" TO PWRDPK-FEEDBACK                              SOBEMAP.
010800     .                                                            SOBEMAP.
010900 RETURN-TO-CALLER.                                                87/12/27
011000     EXIT PROGRAM                                                 SOBEMAP.
011100     .                                                            94/04/20
011200                                                                  SOBEMAP.
011300 ENCRYPT-THE-PASSWORD.                                            SOBEMAP.
011400     MOVE PWRDPK-PASSWORD TO CONVPK-LINE                          SOBEMAP.
011500     MOVE 37 TO CRYPTO-KEY                                        87/12/22
011600     PERFORM ENCRYPT-THE-TEXT                                     87/12/22
011700     MOVE CRYPTO-VALUE TO PWRDPK-CRYPTO-VALUE                     87/12/22
011800                                                                  87/12/22
011900     IF PWRDPK-USER-ID > SPACES                                   87/12/22
012000         MOVE PWRDPK-USER-ID TO CONVPK-LINE                       87/12/22
012100         MOVE 41 TO CRYPTO-KEY                                    87/12/22
012200         PERFORM ENCRYPT-THE-TEXT                                 87/12/22
012300         ADD CRYPTO-VALUE TO PWRDPK-CRYPTO-VALUE                  87/12/22
012400     .                                                            87/12/22
012500                                                                  87/12/22
012600 ENCRYPT-THE-TEXT.                                                87/12/22
012700     CALL "CONVPK"                                                SOBEMAP.
012800         USING CONVPK-CONTROL                                     SOBEMAP.
012900               CONVPK-LINE                                        SOBEMAP.
013000               CONVPK-RESULT                                      87/12/22
013100                                                                  SOBEMAP.
013200     PERFORM SCAN-LINE-BACKWARDS                                  SOBEMAP.
013300       VARYING THIS-CHAR FROM 80 BY -1                            SOBEMAP.
013400         UNTIL CHAR (THIS-CHAR) NOT = SPACE                       SOBEMAP.
013500            OR THIS-CHAR = 8                                      SOBEMAP.
013600                                                                  SOBEMAP.
013700     MOVE THIS-CHAR TO TEXT-LENGTH                                SOBEMAP.
013800                                                                  87/12/22
013900     MOVE ZERO TO CRYPTO-SUM                                      SOBEMAP.
014000                  CRYPTO-NUMBER                                   SOBEMAP.
014100                                                                  SOBEMAP.
014200     PERFORM ENCRYPT-CHAR                                         SOBEMAP.
014300       VARYING THIS-CHAR FROM 1 BY 1                              SOBEMAP.
014400         UNTIL THIS-CHAR > TEXT-LENGTH                            SOBEMAP.
014500                                                                  SOBEMAP.
014600     MOVE CRYPTO-SUM TO CRYPTO-PART1, CRYPTO-PART2                94/04/22
014700     ADD  PWRDPK-CRYPTO-MASK      TO  CRYPTO-PART2                94/04/22
014800                                                                  94/04/22
014900     COMPUTE CRYPTO-MULT1 = CRYPTO-PART1-HI * CRYPTO-PART2-LO     94/04/22
015000     COMPUTE CRYPTO-MULT2 = CRYPTO-PART1-LO * CRYPTO-PART2-HI     94/04/22
015100     COMPUTE CRYPTO-MULT3 = CRYPTO-PART1-LO * CRYPTO-PART2-LO     94/04/22
015200                                                                  94/04/22
015300     MOVE CRYPTO-MULT3 TO CRYPTO-RESULT                           94/04/22
015400     ADD  CRYPTO-MULT2 TO CRYPTO-RESULT-HI                        94/04/22
015500     ADD  CRYPTO-MULT1 TO CRYPTO-RESULT-HI                        94/04/22
015600                                                                  94/04/22
015700     MOVE CRYPTO-RESULT-10 TO CRYPTO-VALUE                        94/04/22
015800     IF CRYPTO-VALUE = ZERO                                       87/01/15
015900         MOVE 1234567890 TO CRYPTO-VALUE                          87/01/15
016000     .                                                            SOBEMAP.
016100                                                                  SOBEMAP.
016200 SCAN-LINE-BACKWARDS.                                             SOBEMAP.
016300     EXIT                                                         SOBEMAP.
016400     .                                                            SOBEMAP.
016500                                                                  SOBEMAP.
016600 ENCRYPT-CHAR.                                                    SOBEMAP.
016700     COMPUTE NEXT-CHAR     = THIS-CHAR + 1                        SOBEMAP.
016800     COMPUTE CRYPTO-SQUARE = CHAR-VALUE (THIS-CHAR)               96/08/15
016900                           * CHAR-VALUE (NEXT-CHAR)               96/08/15
017000                                                                  SOBEMAP.
017100     DIVIDE  CRYPTO-SQUARE BY 127                                 96/08/15
017200             GIVING           CRYPTO-JUNK                         SOBEMAP.
017300             REMAINDER        CRYPTO-TERM                         SOBEMAP.
017400                                                                  SOBEMAP.
017500     COMPUTE CRYPTO-HUGE   = CRYPTO-NUMBER * CRYPTO-KEY           94/04/20
017600                           + CRYPTO-SQUARE * CRYPTO-TERM          SOBEMAP.
017700     MOVE CRYPTO-HUGE-NBR TO CRYPTO-NUMBER                        94/04/20
017800                                                                  SOBEMAP.
017900     COMPUTE CRYPTO-HUGE   = CRYPTO-SUM                           94/04/20
018000                           + CRYPTO-1 * CRYPTO-3                  SOBEMAP.
018100                           + CRYPTO-2 * CRYPTO-1                  SOBEMAP.
018200                           + CRYPTO-3 * CRYPTO-2                  SOBEMAP.
018300     MOVE CRYPTO-HUGE-SUM TO CRYPTO-SUM                           94/04/20
018400     .                                                            SOBEMAP.
018500                                                                  87/12/27
018600 ERASE-THE-PASSWORD.                                              87/12/27
018700     MOVE ZEROES TO ENCRYPTION-VARIABLES                          96/08/15
018800     MOVE SPACES TO PWRDPK-PASSWORD                               87/12/27
018900                    CONVPK-LINE                                   87/12/27
019000                    CONVPK-RESULT                                 87/12/27
019100     .                                                            87/12/27