000100 IDENTIFICATION DIVISION.                                         POS00465
000200 PROGRAM-ID.      NAMEPK.                                         SOBEMAP.
000300                                                                  SOBEMAP.
000400 AUTHOR.          LEIF SVALGAARD.                                 SOBEMAP.
000500 DATE-WRITTEN.    85/11/07                                        88/10/06
000600     -REVISED:    94/12/01.                                       94/12/01
000700                                                                  SOBEMAP.
000800 ENVIRONMENT DIVISION.                                            SOBEMAP.
000900                                                                  SOBEMAP.
001000 CONFIGURATION SECTION.                                           SOBEMAP.
001100 SOURCE-COMPUTER. PORTABLE.                                       SOBEMAP.
001200 OBJECT-COMPUTER. PORTABLE.                                       SOBEMAP.
001300                                                                  SOBEMAP.
001400 DATA DIVISION.                                                   SOBEMAP.
001500                                                                  SOBEMAP.
001600 WORKING-STORAGE SECTION.                                         SOBEMAP.
001700                                                                  SOBEMAP.
001800 01  NAME-CHECKING.                                               SOBEMAP.
001900     02  NAME-CHECK-RESULTS.                                      SOBEMAP.
002000         03  NAME-OK                PIC S9(5)  COMP  VALUE +1.    SOBEMAP.
002100         03  NAME-ERROR             PIC S9(5)  COMP  VALUE -1.    SOBEMAP.
002200         03  NAME-BLANK             PIC S9(5)  COMP  VALUE +0.    SOBEMAP.
002300                                                                  SOBEMAP.
002400     02  CHECK-STATE                PIC S9(3)  COMP.              SOBEMAP.
002500     02  CHECK-CLASS                PIC S9(3)  COMP.              SOBEMAP.
002600                                                                  SOBEMAP.
002700     02  CHECK-FROM                 PIC S9(3)  COMP.              SOBEMAP.
002800     02  CHECK-TO                   PIC S9(3)  COMP.              SOBEMAP.
002900                                                                  SOBEMAP.
003000     02  CHECK-ACTION               PIC X.                        SOBEMAP.
003100                                                                  SOBEMAP.
003200     02  CHECK-NAME-MATRIX.                                       SOBEMAP.
003300         03  FILLER                 OCCURS 5 TIMES.               SOBEMAP.
003400             04  FILLER             OCCURS 5 TIMES.               SOBEMAP.
003500                 05  CHECK-NEXT     PIC 9.                        SOBEMAP.
003600                 05  CHECK-WHAT     PIC X.                        SOBEMAP.
003700                                                                  SOBEMAP.
003800     02  COBOL-NAME-MATRIX.                                       SOBEMAP.
003900         03  FILLER                 PIC X(10)  VALUE "1 2S2S5E5E".SOBEMAP.
004000         03  FILLER                 PIC X(10)  VALUE "4 2S2S3S5E".SOBEMAP.
004100         03  FILLER                 PIC X(10)  VALUE "5E2S2S3S5E".SOBEMAP.
004200         03  FILLER                 PIC X(10)  VALUE "4 5E5E5E5E".SOBEMAP.
004300         03  FILLER                 PIC X(10)  VALUE "5 5 5 5 5 ".SOBEMAP.
004400                                                                  SOBEMAP.
004500     02  FILE-NAME-MATRIX.                                        SOBEMAP.
004600         03  FILLER                 PIC X(10)  VALUE "1 2S5E3E5E".SOBEMAP.
004700         03  FILLER                 PIC X(10)  VALUE "4 2S2S3E5E".SOBEMAP.
004800         03  FILLER                 PIC X(10)  VALUE "3 3 3 3 3 ".SOBEMAP.
004900         03  FILLER                 PIC X(10)  VALUE "4 5E5E5E5E".SOBEMAP.
005000         03  FILLER                 PIC X(10)  VALUE "5 5 5 5 5 ".SOBEMAP.
005100                                                                  SOBEMAP.
005200 01  CHARACTER-VALUES.                                            SOBEMAP.
005300     02  CHAR                       PIC X.                        SOBEMAP.
005400         88  CHAR-IS-VOWEL          VALUES ARE  "A", "E", "I",    SOBEMAP.
005500                                                "O", "U".         89/10/24
005600         88  CHAR-TO-KEEP           VALUES ARE  "0" THRU "9".     SOBEMAP.
005700         88  CHAR-TO-DROP           VALUES ARE  "-", ".", "'".    SOBEMAP.
005800                                                                  SOBEMAP.
005900     02  LATEST-VOWEL               PIC X.                        SOBEMAP.
006000         88  VOWEL-SEEN-BEFORE      VALUE IS "V".                 SOBEMAP.
006100                                                                  SOBEMAP.
006200     02  STOP-KIND                  PIC X      VALUE ".".         SOBEMAP.
006300     02  VOWEL-KIND                 PIC X      VALUE "V".         SOBEMAP.
006400     02  OTHER-KIND                 PIC X      VALUE "O".         SOBEMAP.
006500     02  KEEP-KIND                  PIC X      VALUE "K".         SOBEMAP.
006600     02  DROP-KIND                  PIC X      VALUE "D".         SOBEMAP.
006700                                                                  SOBEMAP.
006800     02  ITEM-KIND                  PIC X.                        SOBEMAP.
006900                                                                  SOBEMAP.
007000 01  LIST-ELEMENTS.                                               SOBEMAP.
007100     02  AN-ELEMENT                 OCCURS 31 TIMES.              SOBEMAP.
007200         03  THE-NEXT               PIC S9(3)  COMP.              SOBEMAP.
007300         03  THE-PREV               PIC S9(3)  COMP.              SOBEMAP.
007400         03  THE-KIND               PIC X.                        SOBEMAP.
007500         03  THE-CHAR               PIC X.                        SOBEMAP.
007600                                                                  SOBEMAP.
007700 01  POINTERS.                                                    SOBEMAP.
007800     02  LIST-HEAD                  PIC S9(3)  COMP.              SOBEMAP.
007900     02  FREE-ELEM                  PIC S9(3)  COMP.              SOBEMAP.
008000     02  ELEMENT                    PIC S9(3)  COMP.              SOBEMAP.
008100                                                                  SOBEMAP.
008200     02  NEXT-ELEM                  PIC S9(3)  COMP.              SOBEMAP.
008300     02  PREV-ELEM                  PIC S9(3)  COMP.              SOBEMAP.
008400     02  LAST-ELEM                  PIC S9(3)  COMP.              SOBEMAP.
008500                                                                  SOBEMAP.
008600 01  SCANNING-CONTROL.                                            SOBEMAP.
008700     02  NAME-LENGTH                PIC S9(3)  COMP.              SOBEMAP.
008800     02  CHAR-INDEX                 PIC S9(3)  COMP.              SOBEMAP.
008900     02  MAX-CHAR-INDEX             PIC S9(3)  COMP  VALUE +30.   92/10/05
009000     02  SCANNING                   PIC X(3).                     89/10/24
009100     02  CUR-NAME-CHAR              PIC X.                        88/01/31
009200                                                                  SOBEMAP.
009300 01  FOR-SIMILARITY-CHECK.                                        SOBEMAP.
009400     02  COMP-INDEX                 PIC S9(3)  COMP.              SOBEMAP.
009500     02  NAME-INDEX                 PIC S9(3)  COMP.              SOBEMAP.
009600     02  START-OF-STRING            PIC S9(3)  COMP.              SOBEMAP.
009700                                                                  SOBEMAP.
009800     02  LONGEST-SO-FAR             PIC S9(3)  COMP.              88/01/31
009900     02  SUBSTRING-CONTRIBUTION     PIC S9(5)  COMP.              94/11/24
010000     02  SUBSTRING-LENGTH           PIC S9(3)  COMP.              88/01/31
010100     02  COMPARE-LENGTH             PIC S9(3)  COMP.              88/01/31
010200     02  LONGEST-LENGTH             PIC S9(3)  COMP.              94/12/01
010300     02  LENGTH-DIFFERENCE          PIC S9(3)  COMP.              94/12/01
010400     02  SIMILARITY-WEIGHT          PIC S9(6)V9(3) COMP.          94/11/24
010500                                                                  SOBEMAP.
010600     02  NAME-WEIGHTS.                                            94/11/28
010700         03  FILLER1                PIC 9V9    VALUE 2.0.         94/11/28
010800         03  FILLER2                PIC 9V9    VALUE 1.5.         94/11/28
010900         03  FILLER3                PIC 9V9    VALUE 1.3.         94/11/28
011000         03  FILLER4                PIC 9V9    VALUE 1.1.         94/11/28
011100         03  FILLER5                PIC 9V9    VALUE 1.0.         94/11/28
011200         03  FILLER6                PIC 9V9    VALUE 0.9.         94/11/28
011300         03  FILLER7                PIC 9V9    VALUE 0.8.         94/11/28
011400         03  FILLER8                PIC 9V9    VALUE 0.8.         94/11/28
011500         03  FILLER9                PIC 9V9    VALUE 0.7.         94/11/28
011600         03  FILLER10               PIC 9V9    VALUE 0.7.         94/11/28
011700         03  FILLER11               PIC 9V9    VALUE 0.7.         94/11/28
011800         03  FILLER12               PIC 9V9    VALUE 0.6.         94/11/28
011900         03  FILLER13               PIC 9V9    VALUE 0.6.         94/11/28
012000         03  FILLER14               PIC 9V9    VALUE 0.6.         94/11/28
012100         03  FILLER15               PIC 9V9    VALUE 0.6.         94/11/28
012200         03  FILLER16               PIC 9V9    VALUE 0.6.         94/11/28
012300         03  FILLER17               PIC 9V9    VALUE 0.5.         94/11/28
012400         03  FILLER18               PIC 9V9    VALUE 0.5.         94/11/28
012500         03  FILLER19               PIC 9V9    VALUE 0.5.         94/11/28
012600         03  FILLER20               PIC 9V9    VALUE 0.5.         94/11/28
012700         03  FILLER21               PIC 9V9    VALUE 0.5.         94/11/28
012800         03  FILLER22               PIC 9V9    VALUE 0.4.         94/11/28
012900         03  FILLER23               PIC 9V9    VALUE 0.4.         94/11/28
013000         03  FILLER24               PIC 9V9    VALUE 0.4.         94/11/28
013100         03  FILLER25               PIC 9V9    VALUE 0.4.         94/11/28
013200         03  FILLER26               PIC 9V9    VALUE 0.4.         94/11/28
013300         03  FILLER27               PIC 9V9    VALUE 0.4.         94/11/28
013400         03  FILLER28               PIC 9V9    VALUE 0.4.         94/11/28
013500         03  FILLER29               PIC 9V9    VALUE 0.4.         94/11/28
013600         03  FILLER30               PIC 9V9    VALUE 0.4.         94/11/28
013700     02  FILLER                     REDEFINES  NAME-WEIGHTS.      94/11/28
013800         03  NAME-WEIGHT            PIC 9V9    OCCURS 30 TIMES.   94/11/28
013900                                                                  94/11/28
014000 LINKAGE SECTION.                                                 SOBEMAP.
014100                                                                  SOBEMAP.
014200 01  NAME-CONTROL.                                                SOBEMAP.
014300     02  SESSION-TASK-ID            PIC X(4).                     SOBEMAP.
014400     02  NAME-OPERATION             PIC X.                        SOBEMAP.
014500         88  CHECK-COBOL-NAME                  VALUE IS "C".      SOBEMAP.
014600         88  CHECK-FILE-NAME                   VALUE IS "F".      SOBEMAP.
014700         88  SHORTEN-NAME                      VALUE IS "S".      SOBEMAP.
014800         88  MATCH-NAMES                       VALUE IS "M".      SOBEMAP.
014900     02  NAME-FEEDBACK              PIC X.                        SOBEMAP.
015000                                                                  SOBEMAP.
015100     02  NAME-AREA                  PIC X(30).                    SOBEMAP.
015200     02  FILLER                     REDEFINES  NAME-AREA.         SOBEMAP.
015300         03  NAME-CHAR              PIC X      OCCURS 30 TIMES.   SOBEMAP.
015400                                                                  SOBEMAP.
015500     02  OTHER-PARAMETERS.                                        SOBEMAP.
015600         03  FILLER                 PIC X(30).                    SOBEMAP.
015700         03  FILLER                 PIC S9(5)  COMP.              SOBEMAP.
015800                                                                  SOBEMAP.
015900     02  PARAMS-FOR-NAME-CHECKING   REDEFINES  OTHER-PARAMETERS.  SOBEMAP.
016000         03  CHECKED-NAME           PIC X(30).                    SOBEMAP.
016100         03  FILLER                 REDEFINES  CHECKED-NAME.      SOBEMAP.
016200             04  CHECK-CHAR         PIC X      OCCURS 30 TIMES.   SOBEMAP.
016300         03  NAME-CHECK-RESULT      PIC S9(5)  COMP.              SOBEMAP.
016400             88  NAME-ERROR-DETECTED           VALUE IS -1.       SOBEMAP.
016500             88  NAME-AREA-IS-BLANK            VALUE IS +0.       SOBEMAP.
016600             88  NAME-IS-OK                    VALUE IS +1.       SOBEMAP.
016700                                                                  SOBEMAP.
016800     02  PARAMS-FOR-SHORTENING      REDEFINES  OTHER-PARAMETERS.  SOBEMAP.
016900         03  SHORT-NAME             PIC X(30).                    SOBEMAP.
017000         03  FILLER                 REDEFINES  SHORT-NAME.        SOBEMAP.
017100             04  SHORT-CHAR         PIC X      OCCURS 30 TIMES.   SOBEMAP.
017200         03  MAX-NAME-LENGTH        PIC S9(5)  COMP.              SOBEMAP.
017300                                                                  SOBEMAP.
017400     02  PARAMS-FOR-MATCHING        REDEFINES  OTHER-PARAMETERS.  SOBEMAP.
017500         03  COMPARE-AREA           PIC X(30).                    SOBEMAP.
017600         03  FILLER                 REDEFINES  COMPARE-AREA.      SOBEMAP.
017700             04  COMPARE-CHAR       PIC X      OCCURS 30 TIMES.   SOBEMAP.
017800         03  SIMILARITY-INDEX       PIC S9(5)  COMP.              SOBEMAP.
017900                                                                  SOBEMAP.
018000 PROCEDURE DIVISION                                               SOBEMAP.
018100     USING NAME-CONTROL.                                          SOBEMAP.
018200 BEGIN-PROGRAM.                                                   SOBEMAP.
018300     MOVE SPACE TO NAME-FEEDBACK                                  SOBEMAP.
018400                                                                  SOBEMAP.
018500     IF CHECK-COBOL-NAME                                          SOBEMAP.
018600         MOVE COBOL-NAME-MATRIX TO CHECK-NAME-MATRIX              SOBEMAP.
018700         PERFORM CHECK-THE-NAME                                   SOBEMAP.
018800     ELSE                                                         SOBEMAP.
018900     IF CHECK-FILE-NAME                                           SOBEMAP.
019000         MOVE FILE-NAME-MATRIX  TO CHECK-NAME-MATRIX              SOBEMAP.
019100         PERFORM CHECK-THE-NAME                                   SOBEMAP.
019200     ELSE                                                         SOBEMAP.
019300     IF SHORTEN-NAME                                              SOBEMAP.
019400         PERFORM SHORTEN-THE-NAME                                 SOBEMAP.
019500     ELSE                                                         SOBEMAP.
019600     IF MATCH-NAMES                                               SOBEMAP.
019700         IF NAME-AREA = COMPARE-AREA                              94/11/23
019800             MOVE 99999 TO SIMILARITY-INDEX                       94/11/24
019900         ELSE                                                     94/11/23
020000             PERFORM COMPUTE-SIMILARITY-INDEX                     94/11/23
020100     ELSE                                                         SOBEMAP.
020200         MOVE "O" TO NAME-FEEDBACK                                SOBEMAP.
020300     .                                                            SOBEMAP.
020400 RETURN-TO-CALLER.                                                SOBEMAP.
020500     EXIT PROGRAM                                                 SOBEMAP.
020600     .                                                            SOBEMAP.
020700                                                                  SOBEMAP.
020800*************************  CHECK THE NAME  ***********************SOBEMAP.
020900                                                                  SOBEMAP.
021000 CHECK-THE-NAME.                                                  SOBEMAP.
021100     MOVE 0 TO CHECK-TO                                           SOBEMAP.
021200     MOVE 1 TO CHECK-STATE                                        SOBEMAP.
021300                                                                  SOBEMAP.
021400     MOVE SPACES  TO CHECKED-NAME                                 SOBEMAP.
021500     MOVE NAME-OK TO NAME-CHECK-RESULT                            SOBEMAP.
021600                                                                  SOBEMAP.
021700     PERFORM CHECK-NAME-CHARACTER                                 SOBEMAP.
021800       VARYING CHECK-FROM FROM 1 BY 1                             SOBEMAP.
021900         UNTIL CHECK-FROM > 30                                    SOBEMAP.
022000                                                                  SOBEMAP.
022100     IF NAME-IS-OK                                                SOBEMAP.
022200         IF CHECK-TO = ZERO                                       SOBEMAP.
022300             MOVE NAME-BLANK TO NAME-CHECK-RESULT                 SOBEMAP.
022400     .                                                            SOBEMAP.
022500                                                                  SOBEMAP.
022600 CHECK-NAME-CHARACTER.                                            SOBEMAP.
022700     PERFORM GET-AND-CLASSIFY-NAME-CHAR                           SOBEMAP.
022800     MOVE CHECK-WHAT (CHECK-STATE, CHECK-CLASS) TO CHECK-ACTION   SOBEMAP.
022900     MOVE CHECK-NEXT (CHECK-STATE, CHECK-CLASS) TO CHECK-STATE    SOBEMAP.
023000                                                                  SOBEMAP.
023100     IF CHECK-ACTION = SPACE                                      SOBEMAP.
023200         NEXT SENTENCE                                            SOBEMAP.
023300     ELSE                                                         SOBEMAP.
023400     IF CHECK-ACTION = "S"                                        SOBEMAP.
023500         ADD 1 TO CHECK-TO                                        SOBEMAP.
023600         MOVE CHAR TO CHECK-CHAR (CHECK-TO)                       SOBEMAP.
023700     ELSE                                                         SOBEMAP.
023800     IF CHECK-ACTION = "E"                                        SOBEMAP.
023900         MOVE NAME-ERROR TO NAME-CHECK-RESULT                     SOBEMAP.
024000     .                                                            SOBEMAP.
024100                                                                  SOBEMAP.
024200 GET-AND-CLASSIFY-NAME-CHAR.                                      SOBEMAP.
024300     MOVE NAME-CHAR (CHECK-FROM) TO CHAR                          SOBEMAP.
024400                                                                  SOBEMAP.
024500     IF CHAR = SPACE                                              SOBEMAP.
024600         MOVE 1 TO CHECK-CLASS                                    SOBEMAP.
024700     ELSE                                                         SOBEMAP.
024800     IF CHAR IS ALPHABETIC                                        SOBEMAP.
024900         MOVE 2 TO CHECK-CLASS                                    SOBEMAP.
025000     ELSE                                                         SOBEMAP.
025100     IF CHAR IS NUMERIC                                           SOBEMAP.
025200         MOVE 3 TO CHECK-CLASS                                    SOBEMAP.
025300     ELSE                                                         SOBEMAP.
025400     IF CHAR = "-"                                                SOBEMAP.
025500         MOVE 4 TO CHECK-CLASS                                    SOBEMAP.
025600     ELSE                                                         SOBEMAP.
025700         MOVE 5 TO CHECK-CLASS                                    SOBEMAP.
025800     .                                                            SOBEMAP.
025900                                                                  SOBEMAP.
026000**********************  SHORTEN THE NAME  ************************SOBEMAP.
026100                                                                  SOBEMAP.
026200 SHORTEN-THE-NAME.                                                SOBEMAP.
026300     PERFORM INIT-LIST-STORAGE                                    SOBEMAP.
026400     PERFORM UNPACK-THE-NAME                                      SOBEMAP.
026500                                                                  SOBEMAP.
026600     PERFORM REMOVE-CHARS-FROM-NAME                               SOBEMAP.
026700       UNTIL NAME-LENGTH NOT > MAX-NAME-LENGTH                    SOBEMAP.
026800     .                                                            SOBEMAP.
026900     PERFORM PACK-THE-NAME                                        SOBEMAP.
027000     .                                                            SOBEMAP.
027100                                                                  SOBEMAP.
027200 INIT-LIST-STORAGE.                                               SOBEMAP.
027300     MOVE 1 TO LIST-HEAD                                          SOBEMAP.
027400     MOVE LIST-HEAD TO THE-NEXT (LIST-HEAD)                       SOBEMAP.
027500     MOVE LIST-HEAD TO THE-PREV (LIST-HEAD)                       SOBEMAP.
027600     MOVE STOP-KIND TO THE-KIND (LIST-HEAD)                       SOBEMAP.
027700     MOVE SPACE     TO THE-CHAR (LIST-HEAD)                       SOBEMAP.
027800                                                                  SOBEMAP.
027900     MOVE 1 TO FREE-ELEM                                          SOBEMAP.
028000     .                                                            SOBEMAP.
028100                                                                  SOBEMAP.
028200 UNPACK-THE-NAME.                                                 SOBEMAP.
028300     MOVE ZERO   TO NAME-LENGTH                                   SOBEMAP.
028400     MOVE SPACE  TO LATEST-VOWEL                                  SOBEMAP.
028500     MOVE SPACES TO SHORT-NAME                                    SOBEMAP.
028600                                                                  SOBEMAP.
028700     PERFORM GET-AND-LINK-CHAR                                    SOBEMAP.
028800       VARYING CHAR-INDEX FROM 1 BY 1                             SOBEMAP.
028900         UNTIL CHAR-INDEX > MAX-CHAR-INDEX                        92/10/05
029000            OR NAME-CHAR (CHAR-INDEX) = SPACE                     92/10/05
029100                                                                  SOBEMAP.
029200     MOVE THE-PREV (LIST-HEAD) TO ELEMENT                         SOBEMAP.
029300     IF THE-KIND (ELEMENT) = VOWEL-KIND                           SOBEMAP.
029400         MOVE OTHER-KIND TO THE-KIND (ELEMENT)                    SOBEMAP.
029500     .                                                            SOBEMAP.
029600     MOVE THE-NEXT (LIST-HEAD) TO ELEMENT                         SOBEMAP.
029700     IF THE-KIND (ELEMENT) = OTHER-KIND                           SOBEMAP.
029800         MOVE KEEP-KIND  TO THE-KIND (ELEMENT)                    SOBEMAP.
029900     .                                                            SOBEMAP.
030000                                                                  SOBEMAP.
030100 GET-AND-LINK-CHAR.                                               SOBEMAP.
030200     ADD 1 TO FREE-ELEM.                                          SOBEMAP.
030300     MOVE FREE-ELEM TO ELEMENT                                    SOBEMAP.
030400                                                                  SOBEMAP.
030500     MOVE NAME-CHAR (CHAR-INDEX)                                  SOBEMAP.
030600       TO THE-CHAR (ELEMENT), CHAR                                SOBEMAP.
030700                                                                  SOBEMAP.
030800     IF CHAR-TO-KEEP                                              SOBEMAP.
030900         MOVE KEEP-KIND TO THE-KIND (ELEMENT)                     SOBEMAP.
031000     ELSE                                                         SOBEMAP.
031100     IF CHAR-IS-VOWEL                                             SOBEMAP.
031200         IF VOWEL-SEEN-BEFORE                                     SOBEMAP.
031300             MOVE VOWEL-KIND TO THE-KIND (ELEMENT)                SOBEMAP.
031400         ELSE                                                     SOBEMAP.
031500             MOVE KEEP-KIND  TO THE-KIND (ELEMENT)                SOBEMAP.
031600             MOVE VOWEL-KIND TO LATEST-VOWEL                      SOBEMAP.
031700     ELSE                                                         SOBEMAP.
031800     IF CHAR-TO-DROP                                              SOBEMAP.
031900         MOVE DROP-KIND  TO THE-KIND (ELEMENT)                    SOBEMAP.
032000     ELSE                                                         SOBEMAP.
032100         MOVE OTHER-KIND TO THE-KIND (ELEMENT)                    SOBEMAP.
032200     .                                                            SOBEMAP.
032300     PERFORM LINK-ELEMENT                                         SOBEMAP.
032400     ADD 1 TO NAME-LENGTH                                         SOBEMAP.
032500     .                                                            SOBEMAP.
032600                                                                  SOBEMAP.
032700 LINK-ELEMENT.                                                    SOBEMAP.
032800     MOVE THE-PREV (LIST-HEAD) TO LAST-ELEM                       SOBEMAP.
032900     MOVE ELEMENT   TO THE-NEXT (LAST-ELEM)                       SOBEMAP.
033000     MOVE ELEMENT   TO THE-PREV (LIST-HEAD)                       SOBEMAP.
033100     MOVE LIST-HEAD TO THE-NEXT (ELEMENT)                         SOBEMAP.
033200     MOVE LAST-ELEM TO THE-PREV (ELEMENT)                         SOBEMAP.
033300     .                                                            SOBEMAP.
033400                                                                  SOBEMAP.
033500 PACK-THE-NAME.                                                   SOBEMAP.
033600     MOVE  ZERO  TO CHAR-INDEX                                    SOBEMAP.
033700     MOVE SPACES TO SHORT-NAME                                    92/09/01
033800     MOVE THE-NEXT (LIST-HEAD) TO ELEMENT                         SOBEMAP.
033900     PERFORM REMOVE-AND-PUT-CHAR                                  SOBEMAP.
034000       UNTIL THE-KIND (ELEMENT) = STOP-KIND                       92/09/01
034100     .                                                            SOBEMAP.
034200                                                                  SOBEMAP.
034300 REMOVE-AND-PUT-CHAR.                                             SOBEMAP.
034400     ADD 1 TO CHAR-INDEX                                          SOBEMAP.
034500     MOVE THE-CHAR (ELEMENT)                                      SOBEMAP.
034600       TO SHORT-CHAR (CHAR-INDEX)                                 SOBEMAP.
034700                                                                  SOBEMAP.
034800     PERFORM REMOVE-ELEMENT                                       SOBEMAP.
034900     MOVE THE-NEXT (LIST-HEAD) TO ELEMENT                         SOBEMAP.
035000     .                                                            SOBEMAP.
035100                                                                  SOBEMAP.
035200 REMOVE-ELEMENT.                                                  SOBEMAP.
035300     MOVE THE-NEXT (ELEMENT)  TO NEXT-ELEM                        SOBEMAP.
035400     MOVE THE-PREV (ELEMENT)  TO PREV-ELEM                        SOBEMAP.
035500     MOVE NEXT-ELEM TO THE-NEXT (PREV-ELEM)                       SOBEMAP.
035600     MOVE PREV-ELEM TO THE-PREV (NEXT-ELEM)                       SOBEMAP.
035700     .                                                            SOBEMAP.
035800                                                                  SOBEMAP.
035900                                                                  SOBEMAP.
036000 REMOVE-CHARS-FROM-NAME.                                          SOBEMAP.
036100     PERFORM REMOVE-LAST-DROP                                     SOBEMAP.
036200     PERFORM REMOVE-LAST-VOWEL                                    SOBEMAP.
036300     PERFORM REMOVE-LAST-VOWEL                                    SOBEMAP.
036400     PERFORM REMOVE-LAST-VOWEL                                    SOBEMAP.
036500     PERFORM REMOVE-LAST-PAIR                                     SOBEMAP.
036600     PERFORM REMOVE-LAST-OTHER                                    SOBEMAP.
036700     IF THE-KIND (ELEMENT) = STOP-KIND                            SOBEMAP.
036800         PERFORM REMOVE-LAST-KEEP                                 SOBEMAP.
036900     .                                                            SOBEMAP.
037000                                                                  SOBEMAP.
037100 REMOVE-LAST-PAIR.                                                SOBEMAP.
037200     MOVE THE-PREV (LIST-HEAD) TO ELEMENT                         SOBEMAP.
037300     MOVE THE-CHAR (ELEMENT)   TO CHAR                            SOBEMAP.
037400                                                                  SOBEMAP.
037500     MOVE "YES" TO SCANNING                                       SOBEMAP.
037600     PERFORM SCAN-BACKWARDS--REMOVE-PAIR                          SOBEMAP.
037700       UNTIL SCANNING = "NO"                                      SOBEMAP.
037800     .                                                            SOBEMAP.
037900                                                                  SOBEMAP.
038000 SCAN-BACKWARDS--REMOVE-PAIR.                                     SOBEMAP.
038100     MOVE THE-PREV (ELEMENT) TO ELEMENT                           SOBEMAP.
038200                                                                  SOBEMAP.
038300     IF THE-KIND (ELEMENT) = STOP-KIND                            SOBEMAP.
038400         MOVE "NO" TO SCANNING                                    SOBEMAP.
038500     ELSE                                                         SOBEMAP.
038600     IF THE-CHAR (ELEMENT) = CHAR                                 SOBEMAP.
038700         PERFORM REMOVE-IF-OTHER-KIND                             SOBEMAP.
038800     ELSE                                                         SOBEMAP.
038900         MOVE THE-CHAR (ELEMENT) TO CHAR                          SOBEMAP.
039000     .                                                            SOBEMAP.
039100                                                                  SOBEMAP.
039200 REMOVE-IF-OTHER-KIND.                                            SOBEMAP.
039300     IF THE-KIND (ELEMENT) = OTHER-KIND                           SOBEMAP.
039400         PERFORM REMOVE-AND-TEST                                  SOBEMAP.
039500     .                                                            SOBEMAP.
039600                                                                  SOBEMAP.
039700 REMOVE-AND-TEST.                                                 SOBEMAP.
039800     PERFORM REMOVE-ELEMENT                                       SOBEMAP.
039900     SUBTRACT 1 FROM NAME-LENGTH                                  SOBEMAP.
040000     IF NAME-LENGTH > MAX-NAME-LENGTH                             SOBEMAP.
040100         MOVE "NO" TO SCANNING                                    SOBEMAP.
040200     ELSE                                                         SOBEMAP.
040300         PERFORM PACK-THE-NAME                                    SOBEMAP.
040400         PERFORM RETURN-TO-CALLER                                 SOBEMAP.
040500     .                                                            SOBEMAP.
040600                                                                  SOBEMAP.
040700 REMOVE-LAST-DROP.                                                SOBEMAP.
040800     MOVE DROP-KIND TO ITEM-KIND                                  SOBEMAP.
040900     PERFORM REMOVE-AN-ITEM                                       SOBEMAP.
041000     .                                                            SOBEMAP.
041100                                                                  SOBEMAP.
041200 REMOVE-LAST-VOWEL.                                               SOBEMAP.
041300     MOVE VOWEL-KIND TO ITEM-KIND                                 SOBEMAP.
041400     PERFORM REMOVE-AN-ITEM                                       SOBEMAP.
041500     .                                                            SOBEMAP.
041600                                                                  SOBEMAP.
041700 REMOVE-AN-ITEM.                                                  SOBEMAP.
041800     MOVE LIST-HEAD TO ELEMENT                                    SOBEMAP.
041900     MOVE "YES" TO SCANNING                                       SOBEMAP.
042000     PERFORM SCAN-BACKWARDS--REMOVE-ITEM                          SOBEMAP.
042100       UNTIL SCANNING = "NO"                                      SOBEMAP.
042200     .                                                            SOBEMAP.
042300                                                                  SOBEMAP.
042400 SCAN-BACKWARDS--REMOVE-ITEM.                                     SOBEMAP.
042500     MOVE THE-PREV (ELEMENT) TO ELEMENT                           SOBEMAP.
042600                                                                  SOBEMAP.
042700     IF THE-KIND (ELEMENT) = STOP-KIND                            SOBEMAP.
042800         MOVE "NO" TO SCANNING                                    SOBEMAP.
042900     ELSE                                                         SOBEMAP.
043000     IF THE-KIND (ELEMENT) = ITEM-KIND                            SOBEMAP.
043100         PERFORM REMOVE-AND-TEST                                  SOBEMAP.
043200     .                                                            SOBEMAP.
043300                                                                  SOBEMAP.
043400 REMOVE-LAST-OTHER.                                               SOBEMAP.
043500     MOVE OTHER-KIND TO ITEM-KIND                                 SOBEMAP.
043600     PERFORM REMOVE-AN-ITEM                                       SOBEMAP.
043700     .                                                            SOBEMAP.
043800                                                                  SOBEMAP.
043900 REMOVE-LAST-KEEP.                                                SOBEMAP.
044000     MOVE KEEP-KIND TO ITEM-KIND                                  SOBEMAP.
044100     PERFORM REMOVE-AN-ITEM                                       SOBEMAP.
044200     .                                                            SOBEMAP.
044300                                                                  SOBEMAP.
044400**********************  MATCH TWO NAMES  *************************SOBEMAP.
044500                                                                  SOBEMAP.
044600 COMPUTE-SIMILARITY-INDEX.                                        SOBEMAP.
044700     MOVE ZEROES TO SIMILARITY-WEIGHT, SIMILARITY-INDEX           94/11/23
044800                    COMPARE-LENGTH   , NAME-LENGTH                94/11/23
044900                                                                  88/01/31
045000     PERFORM GET-COMPARE-LENGTH                                   88/01/31
045100       VARYING COMP-INDEX FROM 1 BY 1                             88/01/31
045200         UNTIL COMP-INDEX > 30                                    94/11/23
045300                                                                  88/01/31
045400     PERFORM GET-NAME-LENGTH                                      88/01/31
045500       VARYING CHAR-INDEX FROM 1 BY 1                             88/01/31
045600         UNTIL CHAR-INDEX > 30                                    94/11/23
045700                                                                  88/01/31
045800     IF NAME-LENGTH > COMPARE-LENGTH                              88/01/31
045900         COMPUTE LENGTH-DIFFERENCE = NAME-LENGTH - COMPARE-LENGTH 88/01/31
046000         MOVE NAME-LENGTH    TO LONGEST-LENGTH                    94/12/01
046100     ELSE                                                         88/01/31
046200         COMPUTE LENGTH-DIFFERENCE = COMPARE-LENGTH - NAME-LENGTH 88/01/31
046300         MOVE COMPARE-LENGTH TO LONGEST-LENGTH                    94/12/01
046400     .                                                            88/01/31
046500     IF COMPARE-LENGTH > ZERO                                     88/01/31
046600         MOVE ZERO TO SUBSTRING-CONTRIBUTION                      94/11/24
046700         MOVE  1   TO CHAR-INDEX                                  94/11/24
046800         PERFORM FIND-SUBSTRINGS                                  88/01/31
046900           UNTIL CHAR-INDEX > NAME-LENGTH                         94/11/24
047000                                                                  94/12/01
047100         COMPUTE SIMILARITY-INDEX = 100 * SIMILARITY-WEIGHT /     94/11/26
047200                    (LONGEST-LENGTH * NAME-WEIGHT (NAME-LENGTH)   94/12/01
047300                      + 2 * LENGTH-DIFFERENCE / LONGEST-LENGTH)   94/12/01
047400     .                                                            88/01/31
047500                                                                  88/01/31
047600 GET-COMPARE-LENGTH.                                              88/01/31
047700     IF COMPARE-CHAR (COMP-INDEX) NOT = SPACE                     88/01/31
047800         MOVE COMP-INDEX TO COMPARE-LENGTH                        88/01/31
047900     .                                                            88/01/31
048000                                                                  88/01/31
048100 GET-NAME-LENGTH.                                                 88/01/31
048200     IF NAME-CHAR (CHAR-INDEX) NOT = SPACE                        88/01/31
048300         MOVE CHAR-INDEX TO NAME-LENGTH                           88/01/31
048400     .                                                            88/01/31
048500                                                                  88/01/31
048600 FIND-SUBSTRINGS.                                                 94/11/24
048700     MOVE      CHAR-INDEX        TO START-OF-STRING               SOBEMAP.
048800     MOVE NAME-CHAR (CHAR-INDEX) TO CUR-NAME-CHAR                 88/01/31
048900                                                                  88/01/31
049000     MOVE  1   TO COMP-INDEX                                      SOBEMAP.
049100     MOVE ZERO TO LONGEST-SO-FAR                                  SOBEMAP.
049200                                                                  SOBEMAP.
049300     PERFORM FIND-LONGEST-SUBSTRING                               SOBEMAP.
049400       UNTIL COMP-INDEX > COMPARE-LENGTH                          88/01/31
049500                                                                  SOBEMAP.
049600     COMPUTE SIMILARITY-WEIGHT = (SIMILARITY-WEIGHT +             94/11/24
049700                  (2 * SUBSTRING-CONTRIBUTION + LONGEST-SO-FAR))  94/11/24
049800                                   / NAME-LENGTH                  94/11/24
049900     ADD 1 TO CHAR-INDEX                                          94/11/23
050000     .                                                            SOBEMAP.
050100                                                                  SOBEMAP.
050200 FIND-LONGEST-SUBSTRING.                                          SOBEMAP.
050300     PERFORM FIND-CHARACTER                                       SOBEMAP.
050400       UNTIL COMP-INDEX > COMPARE-LENGTH                          94/11/23
050500          OR COMPARE-CHAR (COMP-INDEX) = CUR-NAME-CHAR            94/11/23
050600                                                                  SOBEMAP.
050700     MOVE      ZERO       TO SUBSTRING-LENGTH                     SOBEMAP.
050800     MOVE START-OF-STRING TO NAME-INDEX                           SOBEMAP.
050900                                                                  SOBEMAP.
051000     PERFORM MATCH-CHARACTER                                      SOBEMAP.
051100       UNTIL COMP-INDEX > COMPARE-LENGTH                          94/11/23
051200          OR COMPARE-CHAR (COMP-INDEX)                            94/11/23
051300          NOT = NAME-CHAR (NAME-INDEX)                            SOBEMAP.
051400                                                                  SOBEMAP.
051500     PERFORM ADD-TO-CONTRIBUTION 3 TIMES                          94/11/30
051600     IF SUBSTRING-LENGTH > LONGEST-SO-FAR                         94/11/24
051700         MOVE SUBSTRING-LENGTH TO LONGEST-SO-FAR                  94/11/24
051800     .                                                            SOBEMAP.
051900                                                                  SOBEMAP.
052000 FIND-CHARACTER.                                                  SOBEMAP.
052100     ADD 1 TO COMP-INDEX                                          SOBEMAP.
052200     .                                                            SOBEMAP.
052300                                                                  SOBEMAP.
052400 MATCH-CHARACTER.                                                 SOBEMAP.
052500     IF COMP-INDEX = NAME-INDEX                                   94/11/24
052600         ADD 1 TO SUBSTRING-CONTRIBUTION                          94/11/24
052700     .                                                            94/11/24
052800     ADD 1 TO COMP-INDEX                                          SOBEMAP.
052900     IF NAME-INDEX NOT > NAME-LENGTH                              88/01/31
053000         ADD 1 TO NAME-INDEX                                      SOBEMAP.
053100         ADD 1 TO SUBSTRING-LENGTH                                SOBEMAP.
053200     .                                                            SOBEMAP.
053300                                                                  94/11/30
053400 ADD-TO-CONTRIBUTION.                                             94/11/30
053500     ADD SUBSTRING-LENGTH TO SUBSTRING-CONTRIBUTION               94/11/30
053600     .                                                            94/11/30